//+------------------------------------------------------------------+
//|                                                   5_8MACROSS.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//----
extern double Lots=0.1;
extern int StopLoss_bye=150;
extern int StopLoss_sell=150;
extern int TrailingStop=0;
extern int TakeProfit_bye=75;
extern int TakeProfit_sell=25;
extern double delta=0.00032;  //   sar
extern double mastb=0.6;

extern double H_begin=0;
extern double H_end=25;

extern int RSI_P=13;
extern int KPeriod=13;
extern int DPeriod=13;
extern int Slowing=13;
extern int price_field=1; //0..1
//  buy  RSI<=15, Stohastik <=5  
extern double rs_b=50;
extern double st_b=25;
////sell  RSI>=85, Stohastik >=95 
extern double rs_s=50;
extern double st_s=75;




//----
//datetime TimePrev=0;
double TimePrev=0;

int first_b=0, first_s=0,rs;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
  
 
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {int i,j, t0,t1,limit;
   double summ,b,deltaD;
   double lmma[10],lrma[10];
   double fast1;
   double fast2;
   double slow1;
   double slow2;
   double rs0,rs1,st0,st1;
   //Trailing Stop
   //TrailingAlls(TrailingStop);
   //close/Open
   if(TimeHour(TimeCurrent())<H_begin||TimeHour(TimeCurrent())>H_end) 
   { closeshrts();  closelongs();return (0);}


   
   if (TimePrev==Time[0]) return(0);
   TimePrev=Time[0];
   
      t0=1; t1=2;
 
      rs0=iRSI(NULL,0,RSI_P,PRICE_CLOSE,t0); 
      rs1=iRSI(NULL,0,RSI_P,PRICE_CLOSE,t1); 
      st0=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_SMA,price_field,0,t0);
      st1=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_SMA,price_field,0,t1);
      
 Print ("..........", rs0,"     >",st0,"   ",first_b,"    ",first_s);
   if(first_b==0)
   {
   if(rs0<=rs_b&&st0<=st_b)
       {
      closeshrts();
      first_s=0;
     //T/p buy   RSI=75: 
     rs= OrderSend(Symbol(),OP_BUY,Lots,Ask,0,Stoplong(Ask,StopLoss_bye),Takelong(Ask,TakeProfit_bye),NULL,0,0,Blue);
     first_b=1;
     Print ("...............",rs);
     }//long
   }
   
  
  if(first_s==0)
  { 
  if(rs0>=rs_s&&st0>=st_s)
  
     { first_b=0;
      closelongs();
      //T/p sell  RSI=25 
      rs=OrderSend(Symbol(),OP_SELL,Lots,Bid,0,Stopshrt(Bid,StopLoss_sell),Takeshrt(Bid,TakeProfit_sell),NULL,0,0,Red);
     first_s=1;
     Print ("...............",rs);
     }//shrt
  }   
     
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Stoplong(double price,int stop)
  {
   if(stop==0)
      return(0.0);
   return(price-(stop*Point));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Stopshrt(double price,int stop)
  {
   if (stop==0)
      return(0.0);
   return(price+(stop*Point));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Takelong(double price,int Take)
  {
   if (Take==0)
      return(0.0);
   return(price+(Take*Point));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Takeshrt(double price,int Take)
  {
   if (Take==0)
      return(0.0);
   return(price-(Take*Point));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void closelongs()
  {
   int trade;
   int trades=OrdersTotal();
   for(trade=0;trade<trades;trade++)
     {
      OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol())
         continue;
      if(OrderType()==OP_BUY)
        { first_b=0;
        OrderClose(OrderTicket(),OrderLots(),Bid,0,Blue);
      
         }
     }//for
 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void closeshrts()
  {
   int trade;
   int trades=OrdersTotal();
   for(trade=0;trade<trades;trade++)
     {
      OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol())
         continue;
      if(OrderType()==OP_SELL)
       { first_s=0;
         OrderClose(OrderTicket(),OrderLots(),Ask,0,Red);
         
       }
     }//for
  
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void TrailingAlls(int trail)
  {
   if(trail==0)
      return;
//----
   double stopcrnt;
   double stopcal;
   int trade;
   int trades=OrdersTotal();
   for(trade=0;trade<trades;trade++)
     {
      OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol())
         //continue;
         //LONG
         if(OrderType()==OP_BUY)
           {
            stopcrnt=OrderStopLoss();
            stopcal=Bid-(trail*Point);
            if (stopcrnt==0)
              {
               OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
              }
            else
               if(stopcal>stopcrnt)
                 {
                  OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
                 }
           }
     }//LONG
   //Shrt
   if(OrderType()==OP_SELL)
     {
      stopcrnt=OrderStopLoss();
      stopcal=Ask+(trail*Point);
      if (stopcrnt==0)
        {
         OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
        }
      else
         if(stopcal<stopcrnt)
           {
            OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
           }
     }
  }//Shrt
//----
return(0);
//+------------------------------------------------------------------+